searchNodes=[{"doc":"URL cleaning service Usage: iex&gt; url = &quot;www.google.com/search?q=elixir&amp;source=hp&amp;ei=safsa&amp;oq=elixir&amp;gs_lcp=gfsdsadh&quot; iex&gt; MopURL . start_link ( name : MyMopURL ) iex&gt; MopURL . clean ( MyMopURL , url ) { :ok , &quot;https://www.google.com/search?q=elixir&quot; }","ref":"MopURL.html","title":"MopURL","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MopURL.html#child_spec/1","title":"MopURL.child_spec/1","type":"function"},{"doc":"Clean url using instance of mop_url provided","ref":"MopURL.html#clean/2","title":"MopURL.clean/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"MopURL.html#init/1","title":"MopURL.init/1","type":"function"},{"doc":"Start an instance of MopURL Options :name - The name of your MopURL instance. This field is required.","ref":"MopURL.html#start_link/1","title":"MopURL.start_link/1","type":"function"},{"doc":"The :name provided to MopURL in start_link/1 .","ref":"MopURL.html#t:name/0","title":"MopURL.name/0","type":"type"},{"doc":"Cleans URLs using rules. Load rules using new/0 or new/1 . Rules file is a json file of the form: { &quot;providers&quot;: { &quot;rule-label: { // ... rule } } } See MopURL.Rule for explanation about rule format.","ref":"MopURL.Cleaner.html","title":"MopURL.Cleaner","type":"module"},{"doc":"","ref":"MopURL.Cleaner.html#clean/2","title":"MopURL.Cleaner.clean/2","type":"function"},{"doc":"","ref":"MopURL.Cleaner.html#new/0","title":"MopURL.Cleaner.new/0","type":"function"},{"doc":"","ref":"MopURL.Cleaner.html#new/1","title":"MopURL.Cleaner.new/1","type":"function"},{"doc":"Transformation rule specification for removing URL elements Follows https://docs.clearurls.xyz/1.23.0/specs/rules/ Example rule format: { &quot;urlPattern&quot;: &quot;^https?:\\/\\/(?:[a-z0-9-]+\\.)*?doubleclick(?:\\.[a-z]{2,}){1,}&quot;, &quot;completeProvider&quot;: false, &quot;rules&quot;: [], &quot;referralMarketing&quot;: [], &quot;rawRules&quot;: [], &quot;exceptions&quot;: [], &quot;redirections&quot;: [ &quot;^https?:\\/\\/(?:[a-z0-9-]+\\.)*?doubleclick(?:\\.[a-z]{2,}){1,}\\/.*?tag_for_child_directed_treatment=;%3F([^&amp;]*)&quot; ], &quot;forceRedirection&quot;: false } urlPattern The urlPattern is a regular expression, that must match every URL that should be affected by the specified rules, exceptions, or redirections of the provider. The typical structure is &lt; protocol &gt; &lt; subdomain &gt; &lt; domain name &gt; &lt; TLD &gt; &lt; directorie &gt; ?&lt; fields &gt; In most cases the following expression covers all the needs, you only have to substitute the remaining &lt;&gt; fields: ^https?://(?:[a-z0-9-]+\\.)*?&lt;domain name&gt;\\.&lt;TLD&gt; . If you want to match with every TLD, you can substitute the TLD field with (?:[a-z]{2,}){1,} . completeProvider The completeProvider is a boolean, that determines if every URL that matches the urlPattern will be blocked. If you want to specify rules, exceptions, and/or redirections, the value of completeProvider must be false . rules The rules property is a JSON array. Every element in this array will be automatically rewritten to (?:&amp;amp;|[/?#&amp;])(?:{==&lt;field name&gt;==}=[^&amp;]*) to match the field name . The field name can still be a regular expression, but don't have to. If ClearURLs found a field that matches a rule in a given URL the field will be deleted. Only URLs that match the url Pattern will be checked for matching fields. rawRules Because other elements in a URL that should be filtered, besides &quot;well-formed fields&quot; aka normal rules, there is also the rawRules property. Regular expressions formulated in this property can refer to the entire URL and not just to individual fields. They are therefore applied directly to the URL. referralMarketing Since version 1.9.0, you can allow referral marketing in ClearURLs. Previously these fields were always removed. Since some people want to support other people through referral marketing, referral marketing can be allowed in the settings. If referral marketing is allowed, the regular expressions in this array are no longer filtered. Referral Marketing is disabled by default. exceptions The exceptions property is also a JSON array. Every element in this array is a regular expression, that matches a URL. If ClearURLs found a URL, that matches an exception, no further processing on this URL is done. redirections The redirections property is a JSON array. Every element in this array is a regular expression, that matches a URL and must follow a specification. The first regular expression group must be the URL that should be redirected. If ClearURLs find a URL that matches the redirection, the first matching group will be decoded with will decodeURIComponent() and replaces the old URL. forceRedirection Some websites, such as Google, have manipulated URLs ( &lt;a&gt; tags) in such a way that the URL is no longer called normally, rather via a built-in script. The result is that a simple redirect of the URL does no longer work. Thus, to still forward the URL by ClearURLs, there is the property forceRedirection which writes the URL into the main_frame object of the browser.","ref":"MopURL.Rule.html","title":"MopURL.Rule","type":"module"},{"doc":"Every provider has the following properties: urlPattern (required) - match pattern completeProvider (required) - blacklist rules (optional) - transformation rule rawRules (optional) - transformation rule referralMarketing (optional) - transformation rule exceptions (optional) - match pattern exception redirections (optional) - redirection bypass transformation rule forceRedirection (optional) - are tracking elements inserted with js?","ref":"MopURL.Rule.html#__struct__/0","title":"MopURL.Rule.__struct__/0","type":"function"},{"doc":"Apply a rule. Note: rule might return a malformed url. Use MopURL.ValidateURL.cast/1 and MopURL.ValidateURL.validate_hostname/1 to make sure that result is still an URL.","ref":"MopURL.Rule.html#apply/2","title":"MopURL.Rule.apply/2","type":"function"},{"doc":"","ref":"MopURL.Rule.html#new/1","title":"MopURL.Rule.new/1","type":"function"},{"doc":"Simple url editing rule","ref":"MopURL.Rule.html#t:t/0","title":"MopURL.Rule.t/0","type":"type"},{"doc":"URL validator Usage: iex&gt; good_url = cast ( &quot;google.com&quot; ) { :ok , &quot;https://google.com&quot; } iex&gt; validate_hostname ( good_url ) :ok iex&gt; bad_url = cast ( &quot;localhost&quot; ) { :ok , &quot;https://localhost&quot; } iex&gt; validate_hostname ( bad_url ) { :error , &quot;restricted ip&quot; } iex&gt; cast ( &quot;cant-reach-this.com&quot; ) |&gt; validate_hostname ( ) { :error , :nxdomain }","ref":"MopURL.ValidateURL.html","title":"MopURL.ValidateURL","type":"module"},{"doc":"Tries to convert given string to a valid URL. Examples iex&gt; cast ( &quot;HtTps://GOogLE.cOM/search?q=2+323+32&quot; ) { :ok , &quot;https://google.com/search?q=2+323+32&quot; } iex&gt; cast ( &quot;localhost&quot; ) { :ok , &quot;https://localhost&quot; } iex&gt; cast ( &quot;instagram.com&quot; ) { :ok , &quot;https://instagram.com&quot; }","ref":"MopURL.ValidateURL.html#cast/1","title":"MopURL.ValidateURL.cast/1","type":"function"},{"doc":"Checks if a ip is restricted (not in global scope) Examples iex&gt; IP.Address . from_string! ( &quot;127.0.0.1&quot; ) |&gt; is_restricted_ip ( ) true iex&gt; IP.Address . from_string! ( &quot;0.0.0.0&quot; ) |&gt; is_restricted_ip ( ) true iex&gt; IP.Address . from_string! ( &quot;142.251.215.238&quot; ) |&gt; is_restricted_ip ( ) false","ref":"MopURL.ValidateURL.html#is_restricted_ip/1","title":"MopURL.ValidateURL.is_restricted_ip/1","type":"function"},{"doc":"Checks url format using a regular expression. Examples iex&gt; is_valid_format ( &quot;HtTps://GOogLE.cOM/search?q=elixir+fresh&quot; ) true iex&gt; is_valid_format ( &quot;ipfs://GOogLE.cOM/search?q=elixir+fresh&quot; ) false","ref":"MopURL.ValidateURL.html#is_valid_format/1","title":"MopURL.ValidateURL.is_valid_format/1","type":"function"},{"doc":"Regex that matches properly formatted URLs. Adapted from https://github.com/spence/valid_url and https://gist.github.com/dperini/729294","ref":"MopURL.ValidateURL.html#link_regex/0","title":"MopURL.ValidateURL.link_regex/0","type":"function"},{"doc":"Checks if hostname is resolvable.","ref":"MopURL.ValidateURL.html#resolve_hostname/1","title":"MopURL.ValidateURL.resolve_hostname/1","type":"function"},{"doc":"Checks that given URL has reachable hostname Also makes sure that ip of this hostname is not restricted (doesn't point to local network) Examples iex&gt; validate_hostname ( &quot;https://localhost&quot; ) { :error , &quot;restricted ip&quot; } iex&gt; validate_hostname ( &quot;https://google.com&quot; ) :ok","ref":"MopURL.ValidateURL.html#validate_hostname/1","title":"MopURL.ValidateURL.validate_hostname/1","type":"function"},{"doc":"MopURL URL cleaning service. Casts strings to urls, validates hostnames, and removes redundant and tracking elements. Uses rules from https://github.com/ClearURLs/Rules","ref":"readme.html","title":"README","type":"extras"},{"doc":"In order to use MopURL, you must start it and provide a :name . For example, you can add this to your supervision tree: children = [ { MopURL , name : MyMopURL } ] Once you started it, you can clean your urls using MopURL.clean(MyMopURL, url) .","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Overall: 1000 QPS with local DNS caching server configured (see bench/full_dns.sh ) and 50 QPS (see bench/full.sh ) without DNS caching Just URL validation: can handle at least 50k QPS (see bench/url_validation.sh ) Overall performance is rather small because it requires querying and external DNS server. You can speed this up considerably by setting up a local caching DNS server. For example, using Dnsmasq , Unbound or directly with NetworkManager .","ref":"readme.html#performance","title":"README - Performance","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding mop_url to your list of dependencies in mix.exs : def deps do [ { :mop_url , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/mop_url .","ref":"readme.html#installation","title":"README - Installation","type":"extras"}]